; 

    include \masm32\include\masm32rt.inc

    include countries.inc

    DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD 
    ComboProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

  .data?
    hInstance dd ?
    hCombo    dd ?
    hSbar     dd ?
    butn1     dd ?
    butn2     dd ?
    butn3     dd ?
    butn4     dd ?
    butn5     dd ?
    butn6     dd ?
    butn7     dd ?
    butn8     dd ?
    lpComboProc dd ?

  .code

; 

start:
    fn InitCommonControls

    mov hInstance, rv(GetModuleHandle,NULL)
    fn DialogBoxParam,hInstance,100,0,ADDR DlgProc,0
    fn ExitProcess,eax

; 

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 

    LOCAL parr  :DWORD      ; pointer array
    LOCAL ccnt  :DWORD      ; country count
    LOCAL lcnt  :DWORD      ; combo index counter

    switch uMsg
      case WM_INITDIALOG
        fn SendMessage,hWin,WM_SETICON,1,rv(LoadIcon,hInstance,10)
        mov hCombo, rv(GetDlgItem,hWin,123)
        mov lpComboProc, rv(SetWindowLong,hCombo,GWL_WNDPROC,ComboProc)

        mov hSbar, rv(GetDlgItem,hWin,139)

        fn SendMessage,hSbar,SB_SETTEXT,0," Status Bar Text"

        mov butn1, rv(GetDlgItem,hWin,131)
        mov butn2, rv(GetDlgItem,hWin,132)
        mov butn3, rv(GetDlgItem,hWin,133)
        mov butn4, rv(GetDlgItem,hWin,134)
        mov butn5, rv(GetDlgItem,hWin,135)
        mov butn6, rv(GetDlgItem,hWin,136)
        mov butn7, rv(GetDlgItem,hWin,137)
        mov butn8, rv(GetDlgItem,hWin,138)

      ; -----------------------------------------
      ; load the country names into the combo box
      ; -----------------------------------------
        mov ccnt, rv(ltok,OFFSET country,ADDR parr)

        push esi
        push edi

        mov lcnt, 0
        mov esi, parr
        mov edi, ccnt

      lbl1:
        fn SendMessage,hCombo,CB_INSERTSTRING,lcnt,[esi]
        add lcnt, 1
        add esi, 4
        sub edi, 1
        jnz lbl1

        pop edi
        pop esi

        free parr
      ; -----------------------------------------

      case WM_COMMAND
        switch wParam
          case 131          ; << &Prev.
            fn MessageBox,hWin,"Prev.","Cardfile",MB_OK

          case 132          ; &Next
            fn MessageBox,hWin,"Next","Cardfile",MB_OK

          case 133          ; &Find
            fn MessageBox,hWin,"Find","Cardfile",MB_OK

          case 134          ; &Add
            fn MessageBox,hWin,"Add","Cardfile",MB_OK

          case 135          ; &Save
            fn MessageBox,hWin,"Save","Cardfile",MB_OK

          case 136          ; &Delete
            fn MessageBox,hWin,"Delete","Cardfile",MB_OK

          case 137          ; &P&rint
            fn MessageBox,hWin,"Print","Cardfile",MB_OK

          case 138          ; &Close
            jmp quit_dialog

          case 200          ; file menu close
            jmp quit_dialog

          case 300
            fn MessageBox,hWin,"Interface For A Small Database","Cardfile",MB_OK

        endsw

      case WM_CLOSE
      quit_dialog:
        fn EndDialog,hWin,0

    endsw

    xor eax, eax
    ret

DlgProc endp

; 

ComboProc proc hWin :DWORD,uMsg :DWORD,wParam :DWORD,lParam :DWORD

    switch uMsg
      case WM_COMMAND
        switch [ebp+22]             ; hi word of lParam
          case LBN_SELCHANGE
            nop
        endsw
    endsw

    invoke CallWindowProc,lpComboProc,hWin,uMsg,wParam,lParam

    ret

ComboProc endp

; 


end start
